{ PLEASE, READ THIS IMPORTANT INFORMATION FIRST.
  Class TCountdowntime,  Benot Standaert, 2001.
  Tcountdowntime is a component derived from the class TLabel.
  It uses a timer.

  A boolean property called ACTIVE is set by defaut on False.
  Once ACTIVE is true it starts to count down, when the second, minute and hour
  arrive to zero the property Cfinished is set to true (it's important you
  do not activate this component property during the design time or the count
  down will ALREADY start during the design time.)
  It's also important to not set to true the boolean property Cfinished or you
  will not be able to know when the count down is really finished.

  Let's resume a little bit :
  Set ACTIVE to true during the execution of the application to start the
  count down and CFinished to read the end of the count down, the procedure
  newtime sets the property Cfinished to true when time arrive to 0 hour,
  0 minute and 0 second. Read the Cfinished property to know when the count down
  is over.

  To use this component set :
  the property Csecond as the second to count down.
  the property Cminute as the minute to count down,
  the property Chour as the hour to count down,
  Somewhere you'll have to activate the count down,
  so just set it's property active to true ( a click on a button or whatever
  you want).

  IMPORTANT REMARKS :
   - This remark valid for the properties Csecond, Cminute and Chour : any
   negative values will return to a zero value.
   - This remark valid for Csecond and Cminute : if you give a value superior to
   60, the component will recalculate for you and adjust the time of the count
   down to a proper readable value. Example : 125 in the property Csecond will
   add 2 to the property Cminute and 5 to the property Csecond.
   - The maximum value to count down is 32766 hours 59 minutes 59 seconds.

  To know if the count down reaches the end just read the property Cfinished...
  if CFinished is true it means that the count down has reached zero for
  the second, the minute and the hour.
  Cfinished will give a TRUE result only if the property active was set to true
  and the procedure newtime reads a result equal to zero for the hour and the
  minute and the second!
  WARNING : You can also give a result TRUE to the property CFinished but
  it is a non-sense and will give you an unexpected result.

  All the new properties are here :

  Chour :               Integer, set the hour to count down.
  Cminute :             Integer, set the minute to count down.
  CSecond :             Integer, set the second to count down.
  Active :              Boolean, if true the count down starts.
  CFinished :           Boolean, if true the count down has reached zero for the
                        second, minute and hour (Fh := 0, Fm := 0 and Fs := 0).
  These properties are also new, all of them giving you a STRING result :

  HOUR   : Hour to count down,
  MINUTE : like HOUR but for the minute,
  SECOND : like HOUR but for the second.
  COPYRIGHT : hey, I did this component after all.

  I hate this but here is a disclaimer.

  DISCLAIMER :
  This component is FREEWARE but it is still the property of it's author :
   Benot Standaert, 2001.
  You use this component AT YOUR OWN RISK. I wont be responsible for
  any kind of problem you might encounter. This component is given AS IS.
  If you do not agree with this disclaimer YOU CANNOT INSTALL THIS COMPONENT
  AND ALSO YOU CANNOT USE IT.

  Please, report any bugs and or comments to this Email : tactictoe@yahoo.fr
  I would also appreciate notification of any improvements or/and modification
  you might make to this component!
  }

unit Countdowntime;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TCountdowntime = class(TLabel)
  private
    { Private declarations }
    Tempo               : Ttimer;
    h, m, s             : integer;
  protected
    { Protected declarations }
    FHour               : String;
    FMinute             : String;
    FSecond             : String;
    FCopyright          : String;
    Fs                  : integer;
    Fm                  : integer;
    Fh                  : integer;
    FActive             : Boolean;
    FCFinished          : Boolean;
  public
    { Public declarations }
    constructor create (aowner: tcomponent); override;
    destructor destroy; override;
    procedure newtime (Sender: TObject);
  published
    { Published declarations }
    property Hour:String        read Fhour      write Fhour;
    property Minute:String      read Fminute    write Fminute;
    property Second:String      read Fsecond    write Fsecond;
    property Copyright:String   read Fcopyright;
    property Active:boolean     read Factive    write Factive;
    property CHour:integer      read Fh         write Fh;
    property CMinute:integer    read Fm         write Fm;
    property CSecond:integer    read Fs         write Fs;
    property CFinished:boolean  read FCFinished write FCFinished;
  end;

procedure Register;

implementation

constructor TCountdowntime.create;
 begin
 Inherited create(Aowner);
 FHour := '00';
 FMinute := '10';
 FSecond := '00';
 Fh := 0;
 Fm := 10;
 Fs := 0;
 h := 0;
 m := 0;
 s := 0;
 FCFinished := false;
 FActive := false;
 Fcopyright := ' Benot Standaert, 2001';
 caption := '00:10:00';
 Tempo := Ttimer.create (self);
 with Tempo do begin
  enabled := true;
  interval := 1000;
  ontimer  := newtime;
  end;
end;

destructor TCountdowntime.destroy;
 begin
 Tempo.destroy;
 Inherited destroy;
 end;

procedure TCountdowntime.newtime (Sender: Tobject);
var
XS, XM, XH : Extended;
XSS, XMS, XHS : String;
Dh, Dm, Ds : integer;
begin
{No negative value allowed}
if Fs < 0 then Fs := 0;
if Fm < 0 then Fm := 0;
If Fh < 0 then Fh := 0;
{Readable value only}
If Fs > 60 then
 begin
  XS := Fs;
  XM := Fm;
  XM := XM + (Int (XS/60));
   repeat
    XS := XS - 60;
   until (XS < 60);
  XMS := floattostr (XM);
  Fm := strtoint (XMS);
  XSS := floattostr (XS);
  Fs := strtoint (XSS);
 end;
If Fm > 60 then
 begin
  XM := Fm;
  XH := Fh;
  XH := XH + (Int (XM/60));
  if XH > 32766 then XH := 32766;
   repeat
    XM := XM -60;
   until (XM < 60);
  XHS := floattostr (XH);
  Fh := strtoint (XHS);
  XMS := floattostr (XM);
  Fm := strtoint (XMS);
 end;
{just in case Factive is false, let's set backup values}
 Dh := Fh;
 Dm := Fm;
 Ds := Fs;

{Let's set the value for the countdown}
s := Fs;
m := Fm;
h := Fh;
{countdown  is finished or not?}
if s = 0 then
 if m = 0 then
  if h = 0 then
   begin
    FCFinished := true;
    abort;
   end;
{let's count down}
if s = 0 then
 begin
  if m = 0 then
   begin
    if h = 0 then
     begin
      FCFinished := true;
      abort;
     end
     else begin
      dec (h);
      m := 59;
      s := 59;
     end;
   end
   else begin
    dec (m);
    s := 59;
   end;
 end
else
 begin
 dec (s);
 end;
Fs := s;
Fh := h;
Fm := m;

if Factive = false then
 begin
 Fs := Ds;
 Fh := Dh;
 Fm := Dm;
 end;

{Upgrading the Caption and some properties}
if Fh >= 10 then
 FHour := inttostr (Fh)
else
 FHour := '0' + inttostr (Fh);
if Fm >= 10 then
 FMinute := inttostr (Fm)
else
 FMinute := '0' + inttostr (Fm);
if Fs >= 10 then
 FSecond := inttostr (Fs)
else
 FSecond := '0' + inttostr (Fs);
Caption := (Fhour + ':' + Fminute + ':' + Fsecond);

end;

procedure Register;
begin
  RegisterComponents('Benoit Standaert', [TCountdowntime]);
end;

end.
